## glewlwyd 1.1

=== Makefile ===
#
# Glewlwyd OAuth2 Authorization Server
#
# Makefile used to build the software
#
# Copyright 2016 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

CC=gcc
CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
LIBS=-lc -lulfius -lorcania -ljansson -lyder -lcheck -lpthread -lm -lrt -lsubunit

all: test

clean:
	rm -f *.o glewlwyd_auth_code glewlwyd_client_cred glewlwyd_code glewlwyd_code_client_confidential glewlwyd_implicit glewlwyd_resource_owner_pwd_cred glewlwyd_resource_owner_pwd_cred_client_confidential glewlwyd_refresh_token glewlwyd_refresh_token_client_confidential glewlwyd_delete_token glewlwyd_admin_authorization glewlwyd_crud_scope glewlwyd_crud_user glewlwyd_crud_client glewlwyd_crud_resource glewlwyd_update_user_profile glewlwyd_user_session_user glewlwyd_user_session_admin glewlwyd_user_refresh_token_user glewlwyd_user_refresh_token_admin valgrind.txt

unit-tests.o: unit-tests.c unit-tests.h
	$(CC) $(CFLAGS) -c unit-tests.c

glewlwyd_auth_code: glewlwyd_auth_code.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_auth_code.c unit-tests.o -o glewlwyd_auth_code $(LIBS)

test_glewlwyd_auth_code: glewlwyd_auth_code
	-./glewlwyd_auth_code

glewlwyd_client_cred: glewlwyd_client_cred.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_client_cred.c unit-tests.o -o glewlwyd_client_cred $(LIBS)

test_glewlwyd_client_cred: glewlwyd_client_cred
	-./glewlwyd_client_cred

glewlwyd_code: glewlwyd_code.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_code.c unit-tests.o -o glewlwyd_code $(LIBS)

test_glewlwyd_code: glewlwyd_code
	-./glewlwyd_code

glewlwyd_code_client_confidential: glewlwyd_code_client_confidential.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_code_client_confidential.c unit-tests.o -o glewlwyd_code_client_confidential $(LIBS)

test_glewlwyd_code_client_confidential: glewlwyd_code_client_confidential
	-./glewlwyd_code_client_confidential

glewlwyd_implicit: glewlwyd_implicit.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_implicit.c unit-tests.o -o glewlwyd_implicit $(LIBS)

test_glewlwyd_implicit: glewlwyd_implicit
	-./glewlwyd_implicit

glewlwyd_resource_owner_pwd_cred: glewlwyd_resource_owner_pwd_cred.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_resource_owner_pwd_cred.c unit-tests.o -o glewlwyd_resource_owner_pwd_cred $(LIBS)

test_glewlwyd_resource_owner_pwd_cred: glewlwyd_resource_owner_pwd_cred
	-./glewlwyd_resource_owner_pwd_cred

glewlwyd_resource_owner_pwd_cred_client_confidential: glewlwyd_resource_owner_pwd_cred_client_confidential.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_resource_owner_pwd_cred_client_confidential.c unit-tests.o -o glewlwyd_resource_owner_pwd_cred_client_confidential $(LIBS)

test_glewlwyd_resource_owner_pwd_cred_client_confidential: glewlwyd_resource_owner_pwd_cred_client_confidential
	-./glewlwyd_resource_owner_pwd_cred_client_confidential

glewlwyd_refresh_token: glewlwyd_refresh_token.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_refresh_token.c unit-tests.o -o glewlwyd_refresh_token $(LIBS)

test_glewlwyd_refresh_token: glewlwyd_refresh_token
	-./glewlwyd_refresh_token

glewlwyd_refresh_token_client_confidential: glewlwyd_refresh_token_client_confidential.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_refresh_token_client_confidential.c unit-tests.o -o glewlwyd_refresh_token_client_confidential $(LIBS)

test_glewlwyd_refresh_token_client_confidential: glewlwyd_refresh_token_client_confidential
	-./glewlwyd_refresh_token_client_confidential

glewlwyd_delete_token: glewlwyd_delete_token.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_delete_token.c unit-tests.o -o glewlwyd_delete_token $(LIBS)

test_glewlwyd_delete_token: glewlwyd_delete_token
	-./glewlwyd_delete_token

glewlwyd_admin_authorization: glewlwyd_admin_authorization.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_admin_authorization.c unit-tests.o -o glewlwyd_admin_authorization $(LIBS)

test_glewlwyd_admin_authorization: glewlwyd_admin_authorization
	-./glewlwyd_admin_authorization

glewlwyd_crud_scope: glewlwyd_crud_scope.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_crud_scope.c unit-tests.o -o glewlwyd_crud_scope $(LIBS)

test_glewlwyd_crud_scope: glewlwyd_crud_scope
	-./glewlwyd_crud_scope

glewlwyd_crud_user: glewlwyd_crud_user.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_crud_user.c unit-tests.o -o glewlwyd_crud_user $(LIBS)

test_glewlwyd_crud_user: glewlwyd_crud_user
	-./glewlwyd_crud_user

glewlwyd_crud_client: glewlwyd_crud_client.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_crud_client.c unit-tests.o -o glewlwyd_crud_client $(LIBS)

test_glewlwyd_crud_client: glewlwyd_crud_client
	-./glewlwyd_crud_client

glewlwyd_crud_resource: glewlwyd_crud_resource.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_crud_resource.c unit-tests.o -o glewlwyd_crud_resource $(LIBS)

test_glewlwyd_crud_resource: glewlwyd_crud_resource
	-./glewlwyd_crud_resource

glewlwyd_update_user_profile: glewlwyd_update_user_profile.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_update_user_profile.c unit-tests.o -o glewlwyd_update_user_profile $(LIBS)

# This test has to be launched manually, because it expects an input from the user
test_glewlwyd_update_user_profile: glewlwyd_update_user_profile
	-./glewlwyd_update_user_profile

glewlwyd_user_session_user: glewlwyd_user_session_user.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_user_session_user.c unit-tests.o -o glewlwyd_user_session_user $(LIBS)

test_glewlwyd_user_session_user: glewlwyd_user_session_user
	-./glewlwyd_user_session_user

glewlwyd_user_session_admin: glewlwyd_user_session_admin.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_user_session_admin.c unit-tests.o -o glewlwyd_user_session_admin $(LIBS)

test_glewlwyd_user_session_admin: glewlwyd_user_session_admin
	-./glewlwyd_user_session_admin

glewlwyd_user_refresh_token_user: glewlwyd_user_refresh_token_user.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_user_refresh_token_user.c unit-tests.o -o glewlwyd_user_refresh_token_user $(LIBS)

test_glewlwyd_user_refresh_token_user: glewlwyd_user_refresh_token_user
	-./glewlwyd_user_refresh_token_user

glewlwyd_user_refresh_token_admin: glewlwyd_user_refresh_token_admin.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_user_refresh_token_admin.c unit-tests.o -o glewlwyd_user_refresh_token_admin $(LIBS)

test_glewlwyd_user_refresh_token_admin: glewlwyd_user_refresh_token_admin
	-./glewlwyd_user_refresh_token_admin

test: test_glewlwyd_resource_owner_pwd_cred test_glewlwyd_resource_owner_pwd_cred_client_confidential test_glewlwyd_implicit test_glewlwyd_code test_glewlwyd_code_client_confidential test_glewlwyd_client_cred test_glewlwyd_auth_code test_glewlwyd_refresh_token test_glewlwyd_refresh_token_client_confidential test_glewlwyd_delete_token test_glewlwyd_admin_authorization test_glewlwyd_crud_scope test_glewlwyd_crud_user test_glewlwyd_crud_client test_glewlwyd_crud_resource test_glewlwyd_user_session_user test_glewlwyd_user_session_admin test_glewlwyd_user_refresh_token_user test_glewlwyd_user_refresh_token_admin

=== debian/changelog ===
glewlwyd (1.1-2ubuntu1) artful; urgency=medium

  * Build-depend on libmariadbclient-dev, not default-libmysqlclient-dev,
    since the latter conflicts with libhoel-dev in Ubuntu.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 22 Sep 2017 07:23:46 +0000

glewlwyd (1.1-2) unstable; urgency=medium

  * create fonts stuff within dh_install-indep (Closes: #871623)
  * put font package into fonts section (Closes: #871589)

 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 16 Aug 2017 20:39:01 +0200

glewlwyd (1.1-1) unstable; urgency=medium

  * Initial release

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 07 Aug 2017 19:39:01 +0200

=== debian/control ===
Source: glewlwyd
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 10)
	, libmicrohttpd-dev
	, libjansson-dev
	, libcurl4-gnutls-dev
	, uuid-dev
	, libldap2-dev
	, libmariadbclient-dev
	, libsqlite3-dev
	, libconfig-dev
	, libgnutls28-dev
	, libssl-dev
	, libjwt-dev
	, liborcania-dev
	, libyder-dev
	, libulfius-dev
	, libhoel-dev
Standards-Version: 4.0.0
Homepage: https://github.com/babelouest/glewlwyd
#Vcs-Git: https://anonscm.debian.org/collab-maint/glewlwyd.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/glewlwyd.git

Package: glewlwyd
Architecture: any
Depends: ${shlibs:Depends}, 
	, ${misc:Depends}
	, lsb-base (>=3.0-6)
	, glewlwyd-common 
Description: OAuth2 authentication server providing Json Web Tokens 
 Lightweight, fast and easy to install on small systems. Requires a 
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius 
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens 
 library.

Package: glewlwyd-common
Depends: ${misc:Depends}
	, fonts-glewlwyd
Architecture: all
Description: OAuth2 authentication server providing Json Web Tokens - common files
 Lightweight, fast and easy to install on small systems. Requires a 
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius 
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens 
 library.
 .
 This package contains the architecture independent files.

Package: fonts-glewlwyd
Depends: ${misc:Depends}
	, fonts-font-awesome
Architecture: all
Section: fonts
Multi-Arch: foreign
Description: OAuth2 authentication server providing Json Web Tokens - font files
 Lightweight, fast and easy to install on small systems. Requires a 
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius 
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens 
 library.
 .
 This package contains the needed fonts.

## glewlwyd 1.3.1

=== src/Makefile ===
#
# Glewlwyd OAuth2 Authorization Server
#
# Makefile used to build the software
#
# Copyright 2016-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

CC=gcc
#CC=clang
CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
LIBS=-lc -lulfius -lyder -ljansson -lorcania -lhoel -ljwt -lconfig -lldap -luuid -lgnutls -lcrypt
OBJECTS=glewlwyd.o authorization.o oauth.o webservice.o token.o user.o client.o admin.o scope.o resource.o password.o
PREFIX=/usr/local
CONFIG_FILE=../glewlwyd.conf

all: release

clean:
	rm -f *.o glewlwyd valgrind.txt

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: glewlwyd

release: ADDITIONALFLAGS=-O3

release: glewlwyd

%.o: %.c glewlwyd.h
	$(CC) $(CFLAGS) $<

glewlwyd: $(OBJECTS)
	$(CC) -o $@ $^ $(LIBS)

memcheck: debug
	valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./glewlwyd --config-file=$(CONFIG_FILE) 2>valgrind.txt

test-debug: debug
	./glewlwyd --config-file=$(CONFIG_FILE)

install: glewlwyd
	cp -f glewlwyd $(PREFIX)/bin

=== test/Makefile ===
#
# Glewlwyd OAuth2 Authorization Server
#
# Makefile used to build the software
#
# Copyright 2016 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

CC=gcc
CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
LIBS=-lc -lulfius -lorcania -ljansson -lyder -lcheck -lpthread -lm -lrt -lsubunit -ljwt

all: test

clean:
	rm -f *.o *.log *.err glewlwyd_oauth2_auth_code glewlwyd_oauth2_client_cred glewlwyd_oauth2_code glewlwyd_oauth2_code_client_confidential glewlwyd_oauth2_implicit glewlwyd_oauth2_resource_owner_pwd_cred glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential glewlwyd_oauth2_refresh_token glewlwyd_oauth2_refresh_token_client_confidential glewlwyd_delete_token glewlwyd_admin_authorization glewlwyd_crud_scope glewlwyd_crud_user glewlwyd_crud_client glewlwyd_crud_resource glewlwyd_update_user_profile glewlwyd_user_session_user glewlwyd_user_session_admin glewlwyd_user_refresh_token_user glewlwyd_user_refresh_token_admin glewlwyd_http_auth valgrind.txt

unit-tests.o: unit-tests.c unit-tests.h
	$(CC) $(CFLAGS) -c unit-tests.c

glewlwyd_oauth2_auth_code: glewlwyd_oauth2_auth_code.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_oauth2_auth_code.c unit-tests.o -o glewlwyd_oauth2_auth_code $(LIBS)

test_glewlwyd_oauth2_auth_code: glewlwyd_oauth2_auth_code
	-./run_test.sh ./glewlwyd_oauth2_auth_code

glewlwyd_oauth2_client_cred: glewlwyd_oauth2_client_cred.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_oauth2_client_cred.c unit-tests.o -o glewlwyd_oauth2_client_cred $(LIBS)

test_glewlwyd_oauth2_client_cred: glewlwyd_oauth2_client_cred
	-./run_test.sh ./glewlwyd_oauth2_client_cred

glewlwyd_oauth2_code: glewlwyd_oauth2_code.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_oauth2_code.c unit-tests.o -o glewlwyd_oauth2_code $(LIBS)

test_glewlwyd_oauth2_code: glewlwyd_oauth2_code
	-./run_test.sh ./glewlwyd_oauth2_code

glewlwyd_oauth2_code_client_confidential: glewlwyd_oauth2_code_client_confidential.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_oauth2_code_client_confidential.c unit-tests.o -o glewlwyd_oauth2_code_client_confidential $(LIBS)

test_glewlwyd_oauth2_code_client_confidential: glewlwyd_oauth2_code_client_confidential
	-./run_test.sh ./glewlwyd_oauth2_code_client_confidential

glewlwyd_oauth2_implicit: glewlwyd_oauth2_implicit.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_oauth2_implicit.c unit-tests.o -o glewlwyd_oauth2_implicit $(LIBS)

test_glewlwyd_oauth2_implicit: glewlwyd_oauth2_implicit
	-./run_test.sh ./glewlwyd_oauth2_implicit

glewlwyd_oauth2_resource_owner_pwd_cred: glewlwyd_oauth2_resource_owner_pwd_cred.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_oauth2_resource_owner_pwd_cred.c unit-tests.o -o glewlwyd_oauth2_resource_owner_pwd_cred $(LIBS)

test_glewlwyd_oauth2_resource_owner_pwd_cred: glewlwyd_oauth2_resource_owner_pwd_cred
	-./run_test.sh ./glewlwyd_oauth2_resource_owner_pwd_cred

glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential: glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential.c unit-tests.o -o glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential $(LIBS)

test_glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential: glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential
	-./run_test.sh ./glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential

glewlwyd_oauth2_refresh_token: glewlwyd_oauth2_refresh_token.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_oauth2_refresh_token.c unit-tests.o -o glewlwyd_oauth2_refresh_token $(LIBS)

test_glewlwyd_oauth2_refresh_token: glewlwyd_oauth2_refresh_token
	-./run_test.sh ./glewlwyd_oauth2_refresh_token

glewlwyd_oauth2_refresh_token_client_confidential: glewlwyd_oauth2_refresh_token_client_confidential.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_oauth2_refresh_token_client_confidential.c unit-tests.o -o glewlwyd_oauth2_refresh_token_client_confidential $(LIBS)

test_glewlwyd_oauth2_refresh_token_client_confidential: glewlwyd_oauth2_refresh_token_client_confidential
	-./run_test.sh ./glewlwyd_oauth2_refresh_token_client_confidential

glewlwyd_delete_token: glewlwyd_delete_token.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_delete_token.c unit-tests.o -o glewlwyd_delete_token $(LIBS)

test_glewlwyd_delete_token: glewlwyd_delete_token
	-./run_test.sh ./glewlwyd_delete_token

glewlwyd_admin_authorization: glewlwyd_admin_authorization.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_admin_authorization.c unit-tests.o -o glewlwyd_admin_authorization $(LIBS)

test_glewlwyd_admin_authorization: glewlwyd_admin_authorization
	-./run_test.sh ./glewlwyd_admin_authorization

glewlwyd_crud_scope: glewlwyd_crud_scope.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_crud_scope.c unit-tests.o -o glewlwyd_crud_scope $(LIBS)

test_glewlwyd_crud_scope: glewlwyd_crud_scope
	-./run_test.sh ./glewlwyd_crud_scope

glewlwyd_crud_user: glewlwyd_crud_user.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_crud_user.c unit-tests.o -o glewlwyd_crud_user $(LIBS)

test_glewlwyd_crud_user: glewlwyd_crud_user
	-./run_test.sh ./glewlwyd_crud_user

glewlwyd_crud_client: glewlwyd_crud_client.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_crud_client.c unit-tests.o -o glewlwyd_crud_client $(LIBS)

test_glewlwyd_crud_client: glewlwyd_crud_client
	-./run_test.sh ./glewlwyd_crud_client

glewlwyd_crud_resource: glewlwyd_crud_resource.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_crud_resource.c unit-tests.o -o glewlwyd_crud_resource $(LIBS)

test_glewlwyd_crud_resource: glewlwyd_crud_resource
	-./run_test.sh ./glewlwyd_crud_resource

glewlwyd_user_session_user: glewlwyd_user_session_user.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_user_session_user.c unit-tests.o -o glewlwyd_user_session_user $(LIBS)

test_glewlwyd_user_session_user: glewlwyd_user_session_user
	-./run_test.sh ./glewlwyd_user_session_user

glewlwyd_user_session_admin: glewlwyd_user_session_admin.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_user_session_admin.c unit-tests.o -o glewlwyd_user_session_admin $(LIBS)

test_glewlwyd_user_session_admin: glewlwyd_user_session_admin
	-./run_test.sh ./glewlwyd_user_session_admin

glewlwyd_user_refresh_token_user: glewlwyd_user_refresh_token_user.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_user_refresh_token_user.c unit-tests.o -o glewlwyd_user_refresh_token_user $(LIBS)

test_glewlwyd_user_refresh_token_user: glewlwyd_user_refresh_token_user
	-./run_test.sh ./glewlwyd_user_refresh_token_user

glewlwyd_user_refresh_token_admin: glewlwyd_user_refresh_token_admin.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_user_refresh_token_admin.c unit-tests.o -o glewlwyd_user_refresh_token_admin $(LIBS)

test_glewlwyd_user_refresh_token_admin: glewlwyd_user_refresh_token_admin
	-./run_test.sh ./glewlwyd_user_refresh_token_admin

# This test has to be launched manually, because it expects an input from the user
glewlwyd_update_user_profile: glewlwyd_update_user_profile.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_update_user_profile.c unit-tests.o -o glewlwyd_update_user_profile $(LIBS)

test_glewlwyd_update_user_profile: glewlwyd_update_user_profile
	-./run_test.sh ./glewlwyd_update_user_profile

# This test has to be launched manually, because it requires a different config file
glewlwyd_http_auth: glewlwyd_http_auth.c unit-tests.o
	$(CC) $(CFLAGS) glewlwyd_http_auth.c unit-tests.o -o glewlwyd_http_auth $(LIBS)

test_glewlwyd_http_auth: glewlwyd_http_auth
	-./run_test.sh ./glewlwyd_http_auth

test: test_glewlwyd_oauth2_resource_owner_pwd_cred test_glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential test_glewlwyd_oauth2_implicit test_glewlwyd_oauth2_code test_glewlwyd_oauth2_code_client_confidential test_glewlwyd_oauth2_client_cred test_glewlwyd_oauth2_auth_code test_glewlwyd_oauth2_refresh_token test_glewlwyd_oauth2_refresh_token_client_confidential test_glewlwyd_delete_token test_glewlwyd_admin_authorization test_glewlwyd_crud_scope test_glewlwyd_crud_user test_glewlwyd_crud_client test_glewlwyd_crud_resource test_glewlwyd_user_session_user test_glewlwyd_user_session_admin test_glewlwyd_user_refresh_token_user test_glewlwyd_user_refresh_token_admin

=== debian/changelog ===
glewlwyd (1.3.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.3 (no changes)
  * debian/control: use dh11

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 30 Jan 2018 19:05:19 +0100

glewlwyd (1.2.4-1) unstable; urgency=medium

  * New upstream release

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 21 Nov 2017 18:52:20 +0100

glewlwyd (1.2.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.1 (no changes)
  * debian/control: remove dependency on default-libmysqlclient-dev and
                    let libhoel-dev do the sql magic (Closes: #876714)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 07 Oct 2017 16:33:07 +0200

glewlwyd (1.2-1) unstable; urgency=medium

  * New upstream release
  * move config file to /etc/glewlwyd

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 15 Sep 2017 18:39:08 +0200

glewlwyd (1.1.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.0 (no changes)
  * debian/control: add VCS URLs
  * debian/control: set maintainer to team

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 05 Sep 2017 21:57:32 +0200

=== debian/control ===
Source: glewlwyd
Section: web
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 11)
	, libmicrohttpd-dev
	, libjansson-dev
	, libcurl4-gnutls-dev
	, uuid-dev
	, libldap2-dev
	, libsqlite3-dev
	, libconfig-dev
	, libgnutls28-dev
	, libssl-dev
	, libjwt-dev
	, liborcania-dev
	, libyder-dev
	, libulfius-dev
	, libhoel-dev
Standards-Version: 4.1.3
Homepage: https://github.com/babelouest/glewlwyd
Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/glewlwyd.git
Vcs-Git: https://anonscm.debian.org/git/debian-iot/glewlwyd.git

Package: glewlwyd
Architecture: any
Depends: ${shlibs:Depends},
	, ${misc:Depends}
	, lsb-base (>=3.0-6)
	, glewlwyd-common
Description: OAuth2 authentication server providing Json Web Tokens
 Lightweight, fast and easy to install on small systems. Requires a
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens
 library.

Package: glewlwyd-common
Depends: ${misc:Depends}
	, fonts-glewlwyd
Architecture: all
Description: OAuth2 authentication server providing Json Web Tokens - common files
 Lightweight, fast and easy to install on small systems. Requires a
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens
 library.
 .
 This package contains the architecture independent files.

Package: fonts-glewlwyd
Depends: ${misc:Depends}
	, fonts-font-awesome
Architecture: all
Section: fonts
Multi-Arch: foreign
Description: OAuth2 authentication server providing Json Web Tokens - font files
 Lightweight, fast and easy to install on small systems. Requires a
 MySql or SQLite3 database. Handles LDAP or database for users backend.
 .
 The API backend is fully written in language C, it's based on Ulfius
 HTTP framework, Hoel database framework and Libjwt JSON Web Tokens
 library.
 .
 This package contains the needed fonts.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_install:
	echo "do nothing here"

override_dh_install-indep:
	dh_install
	echo "last installation stuff"
	# move font files to another directory
	rm -rf ./debian/glewlwyd-common/usr/share/glewlwyd/webapp/fonts
	# replace the fonts by ones from the Debian package
	rm ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/FontAwesome.otf
	rm ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/fontawesome-webfont.ttf
	ln -s /usr/share/fonts-font-awesome/fonts/FontAwesome.otf ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/FontAwesome.otf
	ln -s /usr/share/fonts-font-awesome/fonts/fontawesome-webfont.ttf ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/fontawesome-webfont.ttf

## glewlwyd 1.4.6

=== CMakeLists.txt ===
#
# Glewlwyd
#
# CMake file used to build program
#
# Copyright 2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(glewlwyd C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(PROGRAM_VERSION_MAJOR "1")
set(PROGRAM_VERSION_MINOR "4")
set(PROGRAM_VERSION_PATCH "6")
set(PROJECT_DESCRIPTION "OAuth2 authentication server providing Json Web Tokens")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/glewlwyd/issues")
set(ORCANIA_VERSION_DOWNLOAD "1.2.3")
set(YDER_VERSION_DOWNLOAD "1.3.3")
set(ULFIUS_VERSION_DOWNLOAD "2.3.6")
set(HOEL_VERSION_DOWNLOAD "1.4.2")

include(GNUInstallDirs)
include(CheckSymbolExists)

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

include(FindJansson)
set(JANSSON_MIN_VERSION 2.4)
find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
if (JANSSON_FOUND)
    set(LIBS ${JANSSON_LIBRARIES})
endif ()

include(FindLibJWT)
find_package(LibJWT REQUIRED)
if (LIBJWT_FOUND)
    set(LIBS ${LIBS} ${LIBJWT_LIBRARIES})
endif ()

include(FindGnuTLS)
find_package(GnuTLS REQUIRED)
if (GNUTLS_FOUND)
    set(LIBS ${LIBS} ${GNUTLS_LIBRARIES})
endif ()

include(FindLdap)
find_package(Ldap REQUIRED)
if (LDAP_FOUND)
    set(LIBS ${LIBS} ${LDAP_LIBRARIES} "-llber")
    include_directories(${LDAP_INCLUDE_DIRS})
endif ()

include(FindCRYPT)
find_package(CRYPT REQUIRED)
if (CRYPT_FOUND)
    set(LIBS ${LIBS} ${CRYPT_LIBRARIES})
    include_directories(${CRYPT_INCLUDE_DIRS})
endif ()

include(FindLibconfig)
find_package(Libconfig REQUIRED)
if (LIBCONFIG_FOUND)
    set(LIBS ${LIBS} ${LIBCONFIG_LIBRARIES})
    include_directories(${LIBCONFIG_INCLUDE_DIRS})
endif ()

include(FindUUID)
find_package(UUID REQUIRED)
if (UUID_FOUND)
    set(LIBS ${LIBS} ${UUID_LIBRARIES})
    include_directories(${UUID_INCLUDE_DIRS})
endif ()

# build

add_executable(glewlwyd ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd.h
                ${CMAKE_CURRENT_SOURCE_DIR}/src/authorization.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/authorization.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/oauth.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/webservice.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/token.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/user.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/client.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/admin.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/scope.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/resource.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/password.c
                ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd.c )

set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
include(FindOrcania)
find_package(Orcania 1.1 QUIET) # try to find orcania
if (NOT ORCANIA_FOUND)
    include(DownloadProject)
    download_project(PROJ orcania # ... otherwise, download archive
            URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_DOWNLOAD}.tar.gz"
            QUIET)
    add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
    include_directories(${orcania_SOURCE_DIR}/include)
    add_dependencies(glewlwyd orcania)
		set(ORCANIA_LIBRARIES orcania)
endif ()
set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})

set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
include(FindYder)
find_package(Yder 1.1 QUIET) # try to find Yder
if (NOT YDER_FOUND)
    include(DownloadProject)
    option(CHECK_ORCANIA "specific param" off)
    download_project(PROJ yder # ... otherwise, download archive
            URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_DOWNLOAD}.tar.gz"
            QUIET)
    add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
    include_directories(${yder_SOURCE_DIR}/include)
    include_directories(${orcania_SOURCE_DIR}/include)
    add_dependencies(glewlwyd yder)
		set(YDER_LIBRARIES yder)
endif ()
set(LIBS ${LIBS} ${YDER_LIBRARIES})

set(Ulfius_FIND_QUIETLY ON)
include(FindUlfius)
find_package(Ulfius 2.2 QUIET)
if (NOT ULFIUS_FOUND)
    include(DownloadProject)
    option(WITH_WEBSOCKET "specific param" off)
    option(INSTALL_HEADER "specific param" off)
    option(CHECK_YDER "specific param" off)
    download_project(PROJ ulfius
            URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_DOWNLOAD}.tar.gz"
            QUIET)
    add_subdirectory(${ulfius_SOURCE_DIR} ${ulfius_BINARY_DIR})
    include_directories(${yder_SOURCE_DIR}/include)
    include_directories(${orcania_SOURCE_DIR}/include)
    include_directories(${ulfius_SOURCE_DIR}/include)
    add_dependencies(glewlwyd ulfius)
		set(ULFIUS_LIBRARIES ulfius)
endif ()
set(LIBS ${LIBS} ${ULFIUS_LIBRARIES})

set(Hoel_FIND_QUIETLY ON)
include(FindHoel)
find_package(Hoel 1.3 QUIET)
if (NOT HOEL_FOUND)
    include(DownloadProject)
    option(WITH_PGSQL "specific param" off)
    option(INSTALL_HEADER "specific param" off)
    option(CHECK_YDER "specific param" off)
    download_project(PROJ hoel
            URL "https://github.com/babelouest/hoel/archive/v${HOEL_VERSION_DOWNLOAD}.tar.gz"
            QUIET)
    add_subdirectory(${hoel_SOURCE_DIR} ${hoel_BINARY_DIR})
    include_directories(${hoel_SOURCE_DIR}/include)
    add_dependencies(glewlwyd hoel)
		set(HOEL_LIBRARIES hoel)
endif ()
set(LIBS ${LIBS} ${HOEL_LIBRARIES})

target_link_libraries(glewlwyd ${LIBS})

# tests

option(BUILD_TESTING "Build the testing tree." OFF)
option(BUILD_TEST_PROFILE "Build test glewlwyd_update_user_profile" OFF)
option(BUILD_TEST_HTTP_AUTH "Build test glewlwyd_http_auth only" OFF)

if (BUILD_TESTING)
    include(FindCheck)
    find_package(Check REQUIRED)
    if (CHECK_FOUND)
        include(FindSubunit)
        find_package(Subunit REQUIRED)

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(LIBS ${LIBS} ${CHECK_LIBRARIES} ulfius yder orcania)
        find_package(Threads REQUIRED)
        set(LIBS ${LIBS} ${SUBUNIT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} m rt)

        if (BUILD_TEST_HTTP_AUTH)
            set(TESTS glewlwyd_http_auth)
        else ()
            set(TESTS glewlwyd_admin_authorization glewlwyd_oauth2_code_client_confidential glewlwyd_user_session_admin glewlwyd_crud_client glewlwyd_oauth2_implicit glewlwyd_user_session_user glewlwyd_crud_resource glewlwyd_oauth2_refresh_token glewlwyd_crud_scope glewlwyd_oauth2_refresh_token_client_confidential glewlwyd_crud_user glewlwyd_oauth2_resource_owner_pwd_cred glewlwyd_delete_token glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential glewlwyd_oauth2_auth_code glewlwyd_oauth2_client_cred glewlwyd_user_refresh_token_admin glewlwyd_oauth2_code glewlwyd_user_refresh_token_user)
            
            if (BUILD_TEST_PROFILE)
                set(TESTS ${TESTS} glewlwyd_update_user_profile)
            endif ()
        endif ()

        configure_file(
                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c ${TST_DIR}/unit-tests.c ${TST_DIR}/unit-tests.h)
            target_include_directories(${t} PUBLIC ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

install(TARGETS glewlwyd
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES docs/glewlwyd.conf.sample
        DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/glewlwyd RENAME glewlwyd.conf COMPONENT config)
install(DIRECTORY webapp/
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/glewlwyd/webapp/ COMPONENT runtime)
install(DIRECTORY docs/database/
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/database/ COMPONENT runtime)
install(FILES README.md
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/ COMPONENT runtime)
install(FILES docs/API.md
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/ COMPONENT runtime)
install(FILES docs/INSTALL.md
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/ COMPONENT runtime)
install(FILES docs/glewlwyd.service
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/ COMPONENT runtime)
install(FILES docs/glewlwyd-init
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/ COMPONENT runtime)

set(TARGETS glewlwyd)

install(TARGETS ${TARGETS}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        CONFIGURATIONS Release)

# uninstall target

if (NOT TARGET uninstall)
    configure_file(
            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY)
    add_custom_target(uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

# packaging

set(CPACK_PACKAGE_VERSION_MAJOR ${PROGRAM_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROGRAM_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROGRAM_VERSION_PATCH})

set(PACKAGE_FILE_NAME
        "${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

set(PACKAGE_IGNORED_FILES
        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

set(CPACK_GENERATOR "TGZ;DEB")

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/glewlwyd")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.3.4), libconfig9, libgnutls30 (>= 3.5.0), libjansson4 (>= 2.7), libldap-2.4-2 (>= 2.4.7), liborcania (>= 1.2), libyder (>= 1.3), libulfius (>= 2.3), libhoel (>= 1.4), libuuid1 (>= 2.16), lsb-base (>= 3.0-6)")
set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})

include(CPack)

add_custom_target(dist_g
        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

=== src/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 CC=gcc
 #CC=clang
 CFLAGS=-c -Wall -D_REENTRANT $(ADDITIONALFLAGS)
-LIBS=-lc -lulfius -lyder -ljansson -lorcania -lhoel -ljwt -lconfig -lldap -luuid -lgnutls -lcrypt
+LIBS=-lc -lulfius -lyder -ljansson -lorcania -lhoel -ljwt -lconfig -lldap -llber -luuid -lgnutls -lcrypt
 OBJECTS=glewlwyd.o authorization.o oauth.o webservice.o token.o user.o client.o admin.o scope.o resource.o password.o
 PREFIX=/usr/local
 CONFIG_FILE=../glewlwyd.conf
@@ -41,10 +41,10 @@
 release: glewlwyd
 
 %.o: %.c glewlwyd.h
-	$(CC) $(CFLAGS) $<
+	$(CC) $(CFLAGS) $(CPPFLAGS) $<
 
 glewlwyd: $(OBJECTS)
-	$(CC) -o $@ $^ $(LIBS)
+	$(CC) -o $@ $^ $(LIBS) $(LDFLAGS)
 
 memcheck: debug
 	valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all ./glewlwyd --config-file=$(CONFIG_FILE) 2>valgrind.txt

=== debian/changelog ===
glewlwyd (1.4.6-1) unstable; urgency=medium

  * New upstream release
  * debian/glewlwyd.postinst: don't check if/usr/share/dbconfig-common/dpkg/
                              files are present, assume they are
  * debian/glewlwyd.config: don't check if/usr/share/dbconfig-common/dpkg/
                            files are present, assume they are
  * Fix lintian warning maintainer-script-lacks-debhelper-token

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 19 Jul 2018 19:51:51 -0400

glewlwyd (1.4.4-3) unstable; urgency=medium

  * debian/postinst: improve auto config

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 09 Jun 2018 15:35:12 -0400

glewlwyd (1.4.4-2) unstable; urgency=medium

  * debian/postinst: force chmod 600 to jwt certificates generated
  * debian/config: remove note template due to lintian warning

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 01 Jun 2018 19:37:57 -0400

glewlwyd (1.4.4-1) unstable; urgency=medium

  * New upstream release
  * debian/postinst: Add dbconfig script

 -- Nicolas Mora <nicolas@babelouest.org>  Wed, 23 May 2018 23:31:51 -0400

glewlwyd (1.4.3-2) unstable; urgency=medium

  * debian/postinst: Improve install with templates

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 19 May 2018 14:43:33 -0400

glewlwyd (1.4.3-1) unstable; urgency=medium

  * New upstream release
  * debian/rules: Use cmake as buildsystem
  * debian/docs: Add documentation

 -- Nicolas Mora <nicolas@babelouest.org>  Mon, 30 Apr 2018 10:44:42 -0400

glewlwyd (1.4.0-1) unstable; urgency=medium

  * New upstream release
  * postinst: Add default config

 -- Nicolas Mora <nicolas@babelouest.org>  Mon, 02 Apr 2018 13:31:00 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,10 @@
 Priority: optional
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
+          , Nicolas Mora <nicolas@babelouest.org>
 Build-Depends: debhelper (>= 11)
+  , dh-exec
+  , po-debconf
 	, libmicrohttpd-dev
 	, libjansson-dev
 	, libcurl4-gnutls-dev
@@ -18,10 +21,11 @@
 	, libyder-dev
 	, libulfius-dev
 	, libhoel-dev
-Standards-Version: 4.1.3
+	, cmake
+Standards-Version: 4.1.4
 Homepage: https://github.com/babelouest/glewlwyd
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/glewlwyd.git
-Vcs-Git: https://anonscm.debian.org/git/debian-iot/glewlwyd.git
+Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
+Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
 
 Package: glewlwyd
 Architecture: any
@@ -29,6 +33,9 @@
 	, ${misc:Depends}
 	, lsb-base (>=3.0-6)
 	, glewlwyd-common
+	, openssl
+	, sqlite3
+  , dbconfig-mysql | dbconfig-sqlite3 | dbconfig-no-thanks,
 Description: OAuth2 authentication server providing Json Web Tokens
  Lightweight, fast and easy to install on small systems. Requires a
  MySql or SQLite3 database. Handles LDAP or database for users backend.

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake --builddirectory=build
 
 override_dh_auto_install:
 	echo "do nothing here"
@@ -30,3 +30,4 @@
 	rm ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/fontawesome-webfont.ttf
 	ln -s /usr/share/fonts-font-awesome/fonts/FontAwesome.otf ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/FontAwesome.otf
 	ln -s /usr/share/fonts-font-awesome/fonts/fontawesome-webfont.ttf ./debian/fonts-glewlwyd/usr/share/glewlwyd/webapp/fonts/fontawesome-webfont.ttf
+	dh_installdocs -A
